import sys

sys.path.append('../pyns')

from game import *
import copy
import gui
import audio

from fighter import *
#from iafighter import *
#from randomfighter import *
from reactivefighter import *
#from kamikazefighter import *
#from blockfighter import *

sounds = dict()
fighterSounds = dict()
fighter2Sounds = dict()

class CalaFightGame(Game):
	def __init__(self, inputFile = None):
		Game.__init__(self, inputFile)
		self.time = 50
		self.players = 1
		self.round = 1
		self.wins = 0
		self.state = "roundStart"
		self.stateTime = 0
		self.kame1 = 0
		self.kame2 = 0

	def setState(self, state):
		self.state = state
		self.stateTime = 0

		if state == "creditos":
			self.gui = self.creditosGui
		elif state == "first":
			self.gui = self.firstscreenGui
			soundManager.LoadMusic("data/casino y furcias.ogg")
			soundManager.PlayMusic(loops=-1)
		elif state == "versus":
			self.gui = self.versusGui
			soundManager.StopMusic()
			sounds["jingle"].Play()
		elif state == "menu":
			self.gui = self.menuGui
			soundManager.LoadMusic("data/casino y furcias.ogg")
			soundManager.PlayMusic(loops=-1)
			self.round = 1
			self.wins = 0
		elif state == "fight":
			self.enemyEntity.paused = False
		elif state == "roundStart":
			self.playerEntity.position.x = -200
			self.playerEntity.position.y = 0
			self.playerEntity.speed.x = 0
			self.playerEntity.speed.y = 0
			self.enemyEntity.position.x = 200
			self.enemyEntity.position.y = 0
			self.enemyEntity.speed.x = 0
			self.enemyEntity.speed.y = 0
			self.playerEntity.newPosition.x = -200
			self.playerEntity.newPosition.y = 0
			self.enemyEntity.newPosition.x = 200
			self.enemyEntity.newPosition.y = 0

			self.playerEntity.sprite.currentAnim = "idle"
			self.enemyEntity.sprite.currentAnim = "idle"

			self.playerEntity.life = 100
			self.gameGui.playerLifeBar.value = 100
			self.enemyEntity.life = 100
			self.gameGui.enemyLifeBar.value = 100

			self.playerEntity.energy = 0
			self.gameGui.playerEnergyBar.value = 0
			self.enemyEntity.energy = 0
			self.gameGui.enemyEnergyBar.value = 0

			self.time = 50

			self.gfxEngine.camera.position.x = 0
			self.gfxEngine.camera.position.y = 200

			self.gameGui.playerRounds.setText(str(self.wins))
			self.gameGui.enemyRounds.setText(str(self.round - self.wins - 1))

			self.gameGui.winLabel.setText("ROUND " + str(self.round))
			if self.round == 1:
				soundManager.LoadMusic("data/furcia fight.ogg")
				soundManager.PlayMusic(loops=-1)
				sounds["1st_round"].Play()
			elif self.round == 2:
				sounds["2nd_round"].Play()
			elif self.round == 3:
				sounds["3rd_round"].Play()

	def update(self, time):
		for u in self.updateFunctions:
			u(time)
			
		

		#self.playerEntity.move(0)
		#self.enemyEntity.move(0)
		diff = self.playerEntity.position.x - self.enemyEntity.position.x
		sigDiff = -1
		if diff > 0:
			sigDiff = 1
		diff = math.fabs(diff)

		self.stateTime+= time

		if self.state == "creditos":
			if self.stateTime > 3:
				self.quit = True
		elif self.state == "first":
			if self.stateTime > 5:
				self.setState("menu")
		elif self.state == "versus":
			if self.stateTime > 5:
				self.gui = self.gameGui
				self.setState("roundStart")
		elif self.state == "roundStart":
			if self.stateTime > 1:
				self.gameGui.winLabel.setText("FIGHT!")
				self.setState("fight")
				sounds["fight"].Play()
		elif self.state == "winlabel":
			if self.stateTime > 4:
				if self.round < 4 and self.wins < 2 and (self.round - self.wins - 1) < 2:
					self.setState("roundStart")
				else:
					self.setState("menu")
		elif self.state == "fight":
			if self.stateTime > 2:
				self.gameGui.winLabel.setText("")

			if not self.input.checkAction("left") and not self.input.checkAction("right"):
				self.playerEntity.move(0)

			if self.input.checkAction("left"):
				self.playerEntity.move(1)
			if self.input.checkAction("right"):
				self.playerEntity.move(2)
			if self.input.checkAction("jump"):
				self.playerEntity.jump()
			if self.input.checkAction("punch"):
				self.playerEntity.punch()
			if self.input.checkAction("kick"):
				self.playerEntity.kick()
			if self.input.checkAction("block"):
				self.playerEntity.block(True)
			else:
				self.playerEntity.block(False)
			if self.input.checkAction("shot"):
				if self.kame1 == 0 and self.playerEntity.energy > 30:
					self.kame1 = sigDiff
					self.playerEntity.energy-= 30
					if sigDiff > 0:
						self.kame1sprite.flip = True
					else:
						self.kame1sprite.flip = False
					self.kame1sprite.culled = False
					self.kame1sprite.position.x = self.playerEntity.position.x - sigDiff * 50

			if self.players == 2:
				if not self.input.checkAction("left2") and not self.input.checkAction("right2"):
					self.enemyEntity.move(0)
	
				if self.input.checkAction("left2"):
					self.enemyEntity.move(1)
				if self.input.checkAction("right2"):
					self.enemyEntity.move(2)
				if self.input.checkAction("jump2"):
					self.enemyEntity.jump()
				if self.input.checkAction("punch2"):
					self.enemyEntity.punch()
				if self.input.checkAction("kick2"):
					self.enemyEntity.kick()
				if self.input.checkAction("block2"):
					self.enemyEntity.block(True)
				else:
					self.enemyEntity.block(False)
				if self.input.checkAction("shot2"):
					if self.kame2 == 0 and self.enemyEntity.energy > 30:
						self.kame2 = sigDiff
						self.enemyEntity.energy-= 30
						if sigDiff > 0:
							self.kame2sprite.flip = True
						else:
							self.kame2sprite.flip = False
						self.kame2sprite.culled = False
						self.kame2sprite.position.x = self.enemyEntity.position.x - sigDiff * 50

			if sigDiff > 0:
				self.playerEntity.sprite.flip = True
				self.enemyEntity.sprite.flip = False
			else:
				self.playerEntity.sprite.flip = False
				self.enemyEntity.sprite.flip = True
	
			if self.playerEntity._punch:
				self.playerEntity._punch = False
				if diff < 75 and not self.enemyEntity._block:
					self.enemyEntity.damage(5)
	
			if self.playerEntity._kick:
				self.playerEntity._kick = False
				if diff < 150 and not self.enemyEntity._block:
					self.enemyEntity.damage(10)
	
			if self.enemyEntity._punch:
				self.enemyEntity._punch = False
				if diff < 75 and not self.playerEntity._block:
					self.playerEntity.damage(5)
	
			if self.enemyEntity._kick:
				self.enemyEntity._kick = False
				if diff < 150 and not self.playerEntity._block:
					self.playerEntity.damage(10)

		if self.state == "fight":
			self.playerEntity.energy+=2*time
			if self.playerEntity.energy > 100:
				self.playerEntity.energy = 100
			self.enemyEntity.energy+=2*time
			if self.enemyEntity.energy > 100:
				self.enemyEntity.energy = 100
				
			self.gameGui.playerEnergyBar.value = self.playerEntity.energy
			self.gameGui.enemyEnergyBar.value = self.enemyEntity.energy

		maxPos = 2344 / 2 - 50
		# que no se escapen
		if self.playerEntity.newPosition.x < -maxPos:
			self.playerEntity.newPosition.x = -maxPos
		if self.enemyEntity.newPosition.x < -maxPos:
			self.enemyEntity.newPosition.x = -maxPos

		if self.playerEntity.newPosition.x > maxPos:
			self.playerEntity.newPosition.x = maxPos
		if self.enemyEntity.newPosition.x > maxPos:
			self.enemyEntity.newPosition.x = maxPos

		if self.kame1:
			self.kame1sprite.position.x-= self.kame1 * time * 300
			if self.kame1sprite.position.x > maxPos or self.kame1sprite.position.x < -maxPos:
				self.kame1 = False
				self.kame1sprite.culled = True

			diffKame1 = math.fabs(self.kame1sprite.position.x - self.enemyEntity.position.x)
			if diffKame1 < 50 and self.enemyEntity.position.y < 50:
				self.kame1 = False
				self.kame1sprite.culled = True
				if self.enemyEntity._block:
					self.enemyEntity.damage(5)
				else:
					self.enemyEntity.damage(30)

		if self.kame2:
			self.kame2sprite.position.x-= self.kame1 * time * 300
			if self.kame2sprite.position.x > maxPos or self.kame2sprite.position.x < -maxPos:
				self.kame2 = False
				self.kame2sprite.culled = True

			diffKame2 = math.fabs(self.kame2sprite.position.x - self.playerEntity.position.x)
			if diffKame2 < 50 and self.playerEntity.position.y < 50:
				self.kame2 = False
				self.kame2sprite.culled = True
				if self.playerEntity._block:
					self.playerEntity.damage(5)
				else:
					self.playerEntity.damage(30)

		collide = False

		if not collide:
			self.playerEntity.position.x = self.playerEntity.newPosition.x
			self.playerEntity.position.y = self.playerEntity.newPosition.y
	
			self.enemyEntity.position.x = self.enemyEntity.newPosition.x
			self.enemyEntity.position.y = self.enemyEntity.newPosition.y

		if diff < 300:
			zoom = 0.75
		else:
			zoom = 0.75 + (diff - 300) / 640

		self.gfxEngine.camera.size.x = 640 * zoom
		self.gfxEngine.camera.size.y = 480 * zoom

		self.gfxEngine.camera.position.x = (self.playerEntity.position.x + self.enemyEntity.position.x) / 2
		self.gfxEngine.camera.position.y = 200 * zoom
		
		minCamera = 320 * zoom  - 2344 / 2
		if self.gfxEngine.camera.position.x < minCamera:
			self.gfxEngine.camera.position.x = minCamera

		maxCamera = -320 * zoom + 2344 / 2
		if self.gfxEngine.camera.position.x > maxCamera:
			self.gfxEngine.camera.position.x = maxCamera

		self.gfxEngine.update(time)

		self.world.update(time)


	def win(self):
		print "WIN"
		if self.playerEntity.life == 100 and self.enemyEntity.life == 0:
			self.gameGui.winLabel.setText("PERFECT");
			sounds["perfect"].Play()
		else:
			self.gameGui.winLabel.setText("YOU WIN");
			sounds["win"].Play()

		self.round+= 1
		self.wins+= 1
		self.setState("winlabel")

	def lose(self):
		print "LOSE"
		self.gameGui.winLabel.setText("YOU LOSE");
		sounds["lose"].Play()
		self.round+= 1
		self.setState("winlabel")

	def end(self):
		print "END"
		print self.round
		self.quit = True

def createGui(gui):
	# barra de vida del jugador
	gui.playerLifeBar = ProgressBar()
	gui.playerLifeBar.position = Vector2d(10, 10)
	gui.playerLifeBar.size = Vector2d(275, 15)
	gui.playerLifeBar.value = 100

	gui.addWidget(gui.playerLifeBar)

	# barra de vida del enemigo/segundo jugador
	gui.enemyLifeBar = ProgressBar()
	gui.enemyLifeBar.position = Vector2d(640 - 10 - 275, 10)
	gui.enemyLifeBar.size = Vector2d(275, 15)
	gui.enemyLifeBar.value = 0

	gui.addWidget(gui.enemyLifeBar)

	# barra de energia del jugador
	gui.playerEnergyBar = ProgressBar()
	gui.playerEnergyBar.position = Vector2d(10, 28)
	gui.playerEnergyBar.size = Vector2d(275, 5)
	gui.playerEnergyBar.value = 0
	gui.playerEnergyBar.color = gfx.Color(1, 1, 0)

	gui.addWidget(gui.playerEnergyBar)

	# barra de energia del enemigo/segundo jugador
	gui.enemyEnergyBar = ProgressBar()
	gui.enemyEnergyBar.position = Vector2d(640 - 10 - 275, 28)
	gui.enemyEnergyBar.size = Vector2d(275, 5)
	gui.enemyEnergyBar.value = 0
	gui.enemyEnergyBar.color = gfx.Color(1, 1, 0)

	gui.addWidget(gui.enemyEnergyBar)

	gui.fontNames = Font("data/comic.ttf", 24)
	gui.fontWinLabel = Font("data/COERCNAK.ttf", 48)

	# nombre jugador
	gui.playerName = Label("furcia", gfx.Color(0, 1, 0), font = gui.fontNames)
	gui.playerName.position = Vector2d(10, 30)

	gui.addWidget(gui.playerName)

	# nombre jugador 2
	gui.enemyName = Label("robot", gfx.Color(1, 0, 0), font = gui.fontNames)
	gui.enemyName.position = Vector2d(640 - 10 - gui.enemyName.size.x, 30)

	gui.addWidget(gui.enemyName)

	# rondas ganadas
	gui.playerRounds = Label("0", gfx.Color(0, 1, 0), font = gui.fontNames)
	gui.playerRounds.position = Vector2d(320 - 50, 30)
	gui.addWidget(gui.playerRounds)

	# rondas ganadas 2
	gui.enemyRounds = Label("0", gfx.Color(1, 0, 0), font = gui.fontNames)
	gui.enemyRounds.position = Vector2d(320 + 35, 30)
	gui.addWidget(gui.enemyRounds)

	# tiempo
	gui.timeLabel = Label("time", gfx.Color(1, 1, 1), font = gui.fontNames)
	gui.timeLabel.position = Vector2d(310, 5)
	
	gui.addWidget(gui.timeLabel)

	# win - lose - perfect
	gui.winLabel = Label("", gfx.Color(0, 1, 0), font = gui.fontWinLabel)
	gui.winLabel.position = Vector2d(220, 240)
	gui.addWidget(gui.winLabel)

"""
En este caso las opciones solo permiten elegir el numero de jugadores
"""
class SetPlayer(MenuAction):
    def __init__(self, player_no):
        self.player_no=player_no
    def perform(self):
        #TODO: modificar
        if self.player_no == 1:
            ia_enabled=True #(no tengo ni idea)
            print "ia_enabled, single player mode"
        else:
            ia_enabled=False
            print "ia_disabled, multiplayer"

def createMenu(gui):
	gui.image = Image("data/fondo_menu.png")
	gui.image.position = Vector2d(0, 0)
	gui.image.size = Vector2d(640, 480)
	gui.addWidget(gui.image)
	
	gui.label = Label("Street Pyther", gfx.Color(0.3, 1.0, 0.5), font = Font("data/COERCNAK.ttf", 48))
	gui.label.position = Vector2d(200, 50)
	gui.addWidget(gui.label)

	gui.menu = Menu()

	gui.item1=Menuitem(SetPlayer(1), "1 Player", Vector2d(55, 150))
	gui.item1._trigger = cb_oneplayer
	gui.item1.color = gfx.Color(0.3, 0.3, 1.0)
	gui.menu.addWidget(gui.item1)
	#gui.setFocus(gui.item1)
	gui.item2=Menuitem(SetPlayer(2), "2 Players", Vector2d(50, 200))
	gui.item2._trigger = cb_twoplayer
	gui.menu.addWidget(gui.item2)

	gui.item3=Menuitem(SetPlayer(3), "Exit", Vector2d(55, 300))
	gui.item3._trigger = cb_exit
	gui.menu.addWidget(gui.item3)


	gui.addWidget(gui.menu)

def cb_oneplayer():
	calaFightGame.players = 1
	calaFightGame.gui = calaFightGame.versusGui
	calaFightGame.setState("versus")

def cb_twoplayer():
	calaFightGame.players = 2
	calaFightGame.gui = calaFightGame.versusGui
	calaFightGame.setState("versus")

def cb_exit():
	calaFightGame.setState("creditos")

def createVersusScreen(gui):
	gui.image = Image("data/vs.png")
	gui.image.position = Vector2d(0, 0)
	gui.image.size = Vector2d(640, 480)
	gui.addWidget(gui.image)	

def createFirstScreen(gui):
	gui.image = Image("data/pantalla_inicio.png")
	gui.image.position = Vector2d(0, 0)
	gui.image.size = Vector2d(640, 480)
	gui.addWidget(gui.image)	

def createCreditosScreen(gui):
	gui.image = Image("data/creditos.png")
	gui.image.position = Vector2d(0, 0)
	gui.image.size = Vector2d(640, 480)
	gui.addWidget(gui.image)	

def createPlayers(game):
	# player
	position = Vector2d(-200, 0)
	game.playerEntity = game.world.createEntity(type = "fighter")
	game.playerEntity.position = copy.copy(position)
	game.playerEntity.newPosition = copy.copy(position)

	game.playerSprite = Sprite()
	game.playerSprite.position = game.playerEntity.position
	game.playerSprite.addFrame("idle", "data/reposo1.png")
	game.playerSprite.addFrame("idle", "data/reposo2.png")
	game.playerSprite.addFrame("walk", "data/reposo1.png")
	game.playerSprite.addFrame("walk", "data/paso1.png")
	game.playerSprite.addFrame("jump", "data/reposo1.png")
	game.playerSprite.addFrame("block", "data/player1cubriendo.png")
	game.playerSprite.addFrame("punch", "data/punyetazo.png")
	game.playerSprite.addFrame("kick", "data/player1patada.png")
	game.playerSprite.addFrame("receive", "data/player1recibiendo.png")
	game.playerSprite.addFrame("ko", "data/ko1.png")
	game.playerSprite.addFrame("ko", "data/ko2.png")
	game.playerSprite.addFrame("ko", "data/ko3.png")
	game.playerSprite.addFrame("ko", "data/ko4.png")
	game.playerSprite.addFrame("ko", "data/ko5.png", center = Vector2d(0, -50))
	game.playerSprite.anim["ko"].loop = False
	#game.playerSprite.anim["ko"].fps = 2

	game.playerEntity.sprite = game.playerSprite
	game.gfxEngine.root.addChild(game.playerSprite)

	game.playerEntity.sounds = fighterSounds
	#enemy
	position = Vector2d(200, 0)
	if game.players == 1:
		game.enemyEntity = game.world.createEntity(type = "iafighter")
	else:
		game.enemyEntity = game.world.createEntity(type = "fighter")
	game.enemyEntity.position = copy.copy(position)
	game.enemyEntity.newPosition = copy.copy(position)

	game.enemySprite = Sprite()
	game.enemySprite.position = game.enemyEntity.position
	#game.enemySprite.color = gfx.Color(1, 0.5, 0.5)

	game.enemySprite.addFrame("idle", "data/player02reposo1.png")
	game.enemySprite.addFrame("idle", "data/player02reposo2.png")
	game.enemySprite.addFrame("walk", "data/player02paso1.png")
	game.enemySprite.addFrame("walk", "data/player02paso2.png")
	game.enemySprite.addFrame("jump", "data/player02paso1.png")
	game.enemySprite.addFrame("block", "data/player02cubriendo.png")
	game.enemySprite.addFrame("punch", "data/player02punyetazo.png")
	game.enemySprite.addFrame("kick", "data/player02patada.png")
	game.enemySprite.addFrame("receive", "data/player02recibiendo.png")
	game.enemySprite.addFrame("ko", "data/player02KO1.png")
	game.enemySprite.addFrame("ko", "data/player02KO2.png")
	game.enemySprite.addFrame("ko", "data/player02KO3.png")
	game.enemySprite.addFrame("ko", "data/player02KO4.png")
	game.enemySprite.addFrame("ko", "data/player02KO5.png")#, center = Vector2d(0, -50))
	game.enemySprite.anim["ko"].loop = False

	game.enemyEntity.sprite = game.enemySprite
	game.gfxEngine.root.addChild(game.enemySprite)

	game.enemyEntity.sounds = fighter2Sounds

	game.enemyEntity.enemy = game.playerEntity
	game.playerEntity.enemy = game.enemyEntity

def cb_perFrame(time):
	if calaFightGame.state == "fight":
		calaFightGame.time-=time

	if calaFightGame.time > 0:
		calaFightGame.gameGui.timeLabel.setText( str(int(calaFightGame.time)) )
	else:
		calaFightGame.gameGui.timeLabel.setText("0")

	if calaFightGame.gameGui.playerLifeBar.value > calaFightGame.playerEntity.life:
		calaFightGame.gameGui.playerLifeBar.value-= time * 20

	if calaFightGame.gameGui.enemyLifeBar.value > calaFightGame.enemyEntity.life:
		calaFightGame.gameGui.enemyLifeBar.value-= time * 20

	# finalizacin
	if calaFightGame.state == "fight":
		if calaFightGame.time <= 0 or calaFightGame.playerEntity.life <= 0 or calaFightGame.enemyEntity.life <= 0:
			if calaFightGame.playerEntity.life > calaFightGame.enemyEntity.life:
				calaFightGame.win()
			else:
				calaFightGame.lose()

			#pausamos al malo
			calaFightGame.enemyEntity.paused = True

def loadSounds():
	sounds["1st_round"] = soundManager.LoadSound("data/sounds/primera_ronda.wav")
	sounds["2nd_round"] = soundManager.LoadSound("data/sounds/segunda_ronda.wav")
	sounds["3rd_round"] = soundManager.LoadSound("data/sounds/ultima_ronda.wav")
	sounds["win"] = soundManager.LoadSound("data/sounds/ganas.wav")
	sounds["lose"] = soundManager.LoadSound("data/sounds/pierdes.wav")
	sounds["perfect"] = soundManager.LoadSound("data/sounds/perfect.wav")
	sounds["fight"] = soundManager.LoadSound("data/sounds/luchen.wav")
	sounds["punch"] = soundManager.LoadSound("data/sounds/puetazo1.wav")
	sounds["kick"] = soundManager.LoadSound("data/sounds/patada1.wav")
	sounds["jingle"] = soundManager.LoadSound("data/sounds/jingle.wav")

	fighterSounds["punch"] = soundManager.LoadSound("data/sounds/puetazo1.wav")
	fighterSounds["kick"] = soundManager.LoadSound("data/sounds/patada1.wav")
	fighterSounds["jump"] = soundManager.LoadSound("data/sounds/salto1.wav")
	fighterSounds["ouch"] = soundManager.LoadSound("data/sounds/ouch1.wav")
	fighterSounds["ko"] = soundManager.LoadSound("data/sounds/ko1.wav")

	fighter2Sounds["punch"] = soundManager.LoadSound("data/sounds/robot-kia.wav")
	fighter2Sounds["kick"] = soundManager.LoadSound("data/sounds/robot-kia.wav")
	fighter2Sounds["jump"] = soundManager.LoadSound("data/sounds/robot-hop.wav")
	fighter2Sounds["ouch"] = soundManager.LoadSound("data/sounds/robot-ouch.wav")
	fighter2Sounds["ko"] = soundManager.LoadSound("data/sounds/robot-disconnected.wav")


pygame.init()

size = (640, 480)

video_flags = OPENGL|DOUBLEBUF|FULLSCREEN

#pygame.mixer.init()
surface = pygame.display.set_mode(size, video_flags)

soundManager=SoundManager(frequency=44100, buffer=4096)

loadSounds()

pygame.mouse.set_visible(False)


calaFightGame = CalaFightGame(inputFile = "input.config")

calaFightGame.versusGui = gui.GUI()
createVersusScreen(calaFightGame.versusGui)

calaFightGame.creditosGui = gui.GUI()
createCreditosScreen(calaFightGame.creditosGui)

calaFightGame.menuGui = gui.GUI()
createMenu(calaFightGame.menuGui)

calaFightGame.gameGui = gui.GUI()
createGui(calaFightGame.gameGui)

calaFightGame.firstscreenGui = gui.GUI()
createFirstScreen(calaFightGame.firstscreenGui)

calaFightGame.updateFunctions.append(cb_perFrame)

calaFightGame.registerEntity("fighter", Fighter(-1))
calaFightGame.registerEntity("iafighter", IAFighter(-1))

fondoSprite = Sprite()
fondoSprite.addFrame("idle", "data/fondo_espacio.jpg")
fondoSprite.position = Vector2d(0, -140)
calaFightGame.gfxEngine.root.addChild(fondoSprite)

calaFightGame.kame1sprite = Sprite()
calaFightGame.kame1sprite.addFrame("idle", "data/bola.png")
calaFightGame.kame1sprite.position = Vector2d(-100, 50)
calaFightGame.kame1sprite.culled = True
calaFightGame.gfxEngine.root.addChild(calaFightGame.kame1sprite)

calaFightGame.kame2sprite = Sprite()
calaFightGame.kame2sprite.addFrame("idle", "data/bola.png")
calaFightGame.kame2sprite.position = Vector2d(100, 50)
calaFightGame.kame2sprite.flip = True
calaFightGame.kame2sprite.culled = True
calaFightGame.gfxEngine.root.addChild(calaFightGame.kame2sprite)


createPlayers(calaFightGame)


calaFightGame.setState("first")


calaFightGame.run()
