import math

# TODO
# cambiar str() por repr()
# operaciones matriz vector
# inicializaciones y trasformaciones en matriz

class Vector2d:
	def __init__(self, x = 0, y = 0):
		self.x = x
		self.y = y
	
	def __len__(self):
		return 2
	
	def set(self, x = 0, y = 0):
		self.x = 0
		self.y = y
	
	def len(self):
		return math.sqrt(self.x * self.x + self.y * self.y)

	def abs(self):
		return math.sqrt(self.x * self.x + self.y * self.y)

	def __add__(self, other):
		return Vector2d(self.x + other.x, self.y + other.y)

	def __iadd__(self, other):
		self.x+= other.x
		self.y+= other.y
		return self

	def __sub__(self, other):
		return Vector2d(self.x - other.x, self.y - other.y)

	def __isub__(self, other):
		self.x-= other.x
		self.y-= other.y
		return self

	def __mul__(self, other):
		return self.x * other.x + self.y * other.y

	def __neg__(self):
		return Vector2d(-self.x, -self.y)

	def __str__(self):
		return "(" + str(self.x) + ", " + str(self.y) + ")"


	def __eq__(self, other):
		return self.x == other.x and self.y == other.y

	def __ne__(self, other):
		return self.x != other.x or self.y != other.y


	def __getitem__(self, k):
		if k == 0:
			return self.x
		elif k == 1:
			return self.y
		else:
			return 0.0

"""
	def __nonzero(self):
		if self.x == 0 and self.y == 0:
			return 
"""


"""
"""
class Matrix3x3:
	def __init__(self):
		self.m00 = 0
		self.m01 = 0
		self.m02 = 0
		self.m10 = 0
		self.m11 = 0
		self.m12 = 0
		self.m20 = 0
		self.m21 = 0
		self.m22 = 0

	def setRotation():
		pass

	def applyRotation():
		pass

class BBox:
	def __init__(self, min = Vector2d(0, 0), max = Vector2d(0, 0)):
		self.min = min
		self.max = max
		self.size = max - min

	def setMin(self, x, y):
		self.min.x = x
		self.min.y = y
		self.size.x = self.max.x - self.min.x
		self.size.y = self.max.y - self.min.y

	def setMax(self, x, y):
		self.max.x = x
		self.max.y = y
		self.size.x = self.max.x - self.min.x
		self.size.y = self.max.y - self.min.y

	def collide(self, bbox):
		if self.min.x > bbox.max.x:
			return False
		if self.max.x < bbox.min.x:
			return False
		if self.min.y > bbox.max.y:
			return False
		if self.max.y < bbox.min.y:
			return False

		return True

#ver como hacer este tipo de test sacarlo a otro fichero algebra.test.py?
if __name__ == "__main__":
	print "testing Vector2d"
	
	a = Vector2d()
	a.x = 1; a.y = 2
	
	print a

	if not (a == Vector2d(1, 2)):
		print "Error"
	if a != Vector2d(1, 2):
		print "Error"
		
	# dimension del vector
	if len(a) != 2:
		print "Dimension incorrecta"

	if a - Vector2d(1, 2) != Vector2d(0, 0):
		print "Suma"

	
