import pygame.mixer

"""Wrapper extremadamente simple para pygame.mixer.
No tengo a mano la documentacion completa, esto es un asco :P
Saludos, slack :P"""

class Sound:
	def __init__(self, filename):
		self.sound = pygame.mixer.Sound(filename)
		self.loopea = 0
		self.endCallback = None

	def Loop(self, nveces):
		"""-1 indica loopear indefinidamente"""
		self.loopea = nveces

	def SetEndCallback(self, callback):
                """No implementado"""
                pass
		#self.endCallback = callback

	def Play(self):
                """Reproduce el sonido en un canal libre.
                Devuelve el objeto pygame.mixer.Channel asignado al sonido"""
                # TODO: Detectar si no quedan canales libres
		return self.sound.play(self.loopea)
	
	def Stop(self):
                return self.sound.stop()

        def SetVolume(self, vol):
                """Ajusta el volumen de reproduccion del sonido.
                vol vale entre 0.0 (silencio) y 1.0 (100%)"""
                self.sound.set_volume(vol)


class SoundManager:
	"""Wrapper de pygame.mixer"""
	
	def __init__(self, numChannels=8, frequency=22050, bits=-16, stereo=True, buffer=1024):
		"""numChannels es el numero maximo de canales para mezclar
		frequency la frecuencia de muestreo
		bits la resolucion de las muestras (positivo -> unsigned; negativo -> signed)
		stereo determina si usar 1 o 2 canales de salida de audio
		buffer es el tam. del buffer de salida: mas grande -> mas latencia"""

		self.numChannels = numChannels
		if pygame.mixer.get_init() != None:
			pygame.mixer.quit()
		pygame.mixer.init(frequency, bits, stereo, buffer)
		pygame.mixer.set_num_channels(numChannels)

		self.channels={}
		for i in range(numChannels):
			self.channels[i]=pygame.mixer.Channel(i)

                self.allocated_sounds={}	
			
	def LoadSound(self, filename):
                """Carga un sonido desde filename (WAV u OGG) y devuelve
                un objeto Sound"""
                try:
                        return self.allocated_sounds[filename]
                except KeyError:
        		s = Sound(filename)
                        self.allocated_sounds[filename] = s
                        return s

	def PlaySound(self, sound):
		sound.Play()

        def LoadMusic(self, filename):
                """Carga un WAV o un OGG de musica de fondo"""
                # Como musica no hay mas que una, reemplazamos la actual sin mas
                pygame.mixer.music.load(filename)

        def PlayMusic(self, loops=0, startpos=0.0):
                """Reproduce la musica, loopeando tantas veces como indique
                loops (-1 == infinitas) y comenzando en startpos"""
                pygame.mixer.music.play(loops, startpos)

        def StopMusic(self):
                """Detiene la musica"""
                pygame.mixer.music.stop()

        def SetMusicVolume(self, vol):
                """Vol debe estar entre 0.0 (silencio) y 1.0 (100%)"""
                pygame.music.set_volume(vol)
        

if __name__=="__main__":
        manager=SoundManager(frequency=44100, buffer=4096)
        manager.LoadMusic("vanguard.ogg")
        manager.PlayMusic()

        while 1:
                pass
        
        



		
